desc 'Prepares application project structure and configuration.'
task :prepare_app_project do |t, args|

  # Prepare common server project structure.
  Rake::Task["prepare_project"].execute

  puts "Creating configuration files"

  app_config_dir = File.join(Dir.pwd, 'config')
  Dir.mkdir(app_config_dir) unless File.directory?(app_config_dir)

  app_config = File.join(app_config_dir, 'app.rb')
  if !File.exists?(app_config)
    out = File.open(app_config, 'w+')
    out.write("# application configuration\n")
    out.write("#UU::OS::Application::Config[:some_param] = 'some value'\n")
    out.write("#\n")
    out.write("#UU::OS::Application::Config.replace({\n")
    out.write("#  :some_param => 'some value'\n")
    out.write("#})\n")
    out.write("#UU::OS::Application::Config.load do |config|\n")
    out.write("#  config[:some_param] = 'some value'\n")
    out.write("#end\n")
    out.close
  end

end
