module UU
  module OS
    module Application
      # @private
      module LogHelper

        # @private
        def log_error(logger, message = nil, exception = nil) # :nodoc:
          msg = build_log_message(message, exception)
          logger.error(msg) unless logger.nil?
        end

        private
        # @private
        def build_log_message(message = nil, exception = nil)
          message, exception = exception, message if message.kind_of?(Exception)
          msg = ''
          return msg if message.nil? && exception.nil?
          if !message.nil? && !message.empty?
            msg << message.to_s
          end
          if !exception.nil?
            msg << "\n  "
            msg << "#{exception.class} [#{exception.id}]: #{exception.message}"
            trace = exception.backtrace
            msg << "\n  " << trace.join("\n  ") if !trace.nil? && !trace.empty?
          end
          return msg
        end

      end
    end
  end
end
